<!--
 * Fetchify
 *
 * @author       	ClearCourse Business Services Ltd t/a Fetchify
 * @link            https://fetchify.com
 * @copyright  		Copyright (c) 2022, ClearCourse Business Services Ltd
 * @version			2.1.0
-->

<?php
	echo $header;
	echo $column_left;
?>
<div id="content">
	<style>
	.ml-0 {
		margin-left: 0;
	}

	.mr-0 {
		margin-right: 0;
	}

	.mt-15 {
		margin-top: 15px;
	}

	.heading {
		font-size: 16px;
	}
	</style>
	<div class="page-header">
		<div class="container-fluid">
			<div class="pull-right">
				<button type="submit" form="form-craftyGlobal" data-toggle="tooltip" title="<?php echo $craftyAdminLabels['button_save']; ?>" class="btn btn-primary">
					<i class="fa fa-save"></i>
				</button>
				<a href="<?php echo $cancel; ?>" data-toggle="tooltip" title="<?php echo $craftyAdminLabels['button_cancel']; ?>" class="btn btn-default">
					<i class="fa fa-reply"></i>
				</a>
			</div>
			<h1><?php echo $craftyAdminLabels['heading_title']; ?></h1>
			<ul class="breadcrumb">
				<?php foreach ($breadcrumbs as $breadcrumb) { ?>
					<li><a href="<?php echo $breadcrumb['href']; ?>"><?php echo $breadcrumb['text']; ?></a></li>
				<?php } ?>
			</ul>
		</div>
	</div>

	<div class="container-fluid">
		<?php if ($error_warning) { ?>
			<div class="alert alert-danger"><i class="fa fa-exclamation-circle"></i> <?php echo $error_warning; ?>
				<button type="button" class="close" data-dismiss="alert">&times;</button>
			</div>
		<?php } ?>
		<div class="panel panel-default">
			<div class="panel-heading">
				<h3 class="panel-title"><i class="fa fa-pencil"></i> <?php echo $craftyAdminLabels['text_edit']; ?></h3>
			</div>
			<div class="panel-body">
				<form action="<?php echo $action; ?>" method="post" enctype="multipart/form-data" id="form-craftyGlobal" class="form-horizontal">
					<!-- General Config -->
					<div class="form-group">
						<div class="row ml-0 mr-0">
							<div class="col-sm-2 control-label">
								<h4 class="heading">General</h4>
							</div>
						</div>
						<div class="row ml-0 mr-0">
							<label class="col-sm-2 control-label" for="craftyGlobal_access_token"><?php echo $craftyAdminLabels['label_access_token']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_access_token" placeholder="xxxxx-xxxxx-xxxxx-xxxxx" type="text" value="<?php echo $craftyGlobal_access_token; ?>" class="form-control"/>
							</div>
						</div>
					</div>

					<!-- Autocomplete Config -->
					<div class="form-group">
						<div class="row ml-0 mr-0">
							<div class="col-sm-2 control-label">
								<h4 class="heading">Autocomplete</h4>
							</div>
						</div>
						<div class="row ml-0 mr-0">
							<label class="col-sm-2 control-label" for="craftyGlobal_autocomplete_status"><?php echo $craftyAdminLabels['label_autocomplete_status']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_autocomplete_status" class="form-control">
									<?php if ($craftyGlobal_autocomplete_status == '1') { ?>
										<option value="1" selected="selected">Enabled</option>
										<option value="0">Disabled</option>
									<?php } else { ?>
											<option value="1">Enabled</option>
											<option value="0" selected="selected">Disabled</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_mode"><?php echo $craftyAdminLabels['label_mode']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_mode"  class="form-control">
									<?php if ($craftyGlobal_mode == '2') { ?>
										<option value="1">Below</option>
										<option value="2" selected="selected">Surround</option>
										<?php } else { ?>
											<option value="1" selected="selected">Below</option>
											<option value="2">Surround</option>
											<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_ambient"><?php echo $craftyAdminLabels['label_ambient']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_ambient" class="form-control">
									<?php if ($craftyGlobal_ambient == 'dark') { ?>
										<option value="light">Light</option>
										<option value="dark" selected="selected">Dark</option>
										<?php } else { ?>
											<option value="light" selected="selected">Light</option>
											<option value="dark">Dark</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_accent"><?php echo $craftyAdminLabels['label_accent']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_accent" type="text" value="<?php if($craftyGlobal_accent == '') echo 'default'; else echo $craftyGlobal_accent; ?>" class="form-control"/>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_showLogo"><?php echo $craftyAdminLabels['label_showLogo']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_showLogo"  class="form-control">
									<?php if ($craftyGlobal_showLogo == '0') { ?>
										<option value="1">Show</option>
										<option value="0" selected="selected">Hide</option>
									<?php } else { ?>
										<option value="1" selected="selected">Show</option>
										<option value="0">Hide</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_useLine1"><?php echo $craftyAdminLabels['label_useLine1']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_useLine1"  class="form-control">
									<?php if ($craftyGlobal_useLine1 == '0') { ?>
										<option value="1">Yes</option>
										<option value="0" selected="selected">No</option>
									<?php } else { ?>
										<option value="1" selected="selected">Yes</option>
										<option value="0">No</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_hideFields"><?php echo $craftyAdminLabels['label_hideFields']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_hideFields"  class="form-control">
									<?php if ($craftyGlobal_hideFields == '0') { ?>
										<option value="1">Yes</option>
										<option value="0" selected="selected">No</option>
									<?php } else { ?>
										<option value="1" selected="selected">Yes</option>
										<option value="0">No</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_default_placeholder"><?php echo $craftyAdminLabels['label_default_placeholder']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_default_placeholder" type="text" value="<?php echo $craftyGlobal_default_placeholder  ?>" placeholder="Start with post/zip code or street" class="form-control"/>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_country_button"><?php echo $craftyAdminLabels['label_country_button']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_country_button" type="text" value="<?php echo $craftyGlobal_country_button ?>" placeholder="Change Country" class="form-control"/>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_country_placeholder"><?php echo $craftyAdminLabels['label_country_placeholder']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_country_placeholder" type="text" value="<?php echo $craftyGlobal_country_placeholder ?>" placeholder="Type here to search for a country" class="form-control"/>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_generic_error"><?php echo $craftyAdminLabels['label_generic_error']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_generic_error" type="text" value="<?php echo $craftyGlobal_generic_error ?>" placeholder="An error occurred. Please enter your address manually" class="form-control"/>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_no_results"><?php echo $craftyAdminLabels['label_no_results']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_no_results" type="text" value="<?php echo $craftyGlobal_no_results ?>" placeholder="No results found" class="form-control"/>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_search_label"><?php echo $craftyAdminLabels['label_search_label']; ?></label>
							<div class="col-sm-10">
								<input name="craftyGlobal_search_label" type="text" value="<?php echo $craftyGlobal_search_label ?>" placeholder="Address Search" class="form-control"/>
							</div>
						</div>
					</div>

					<!-- Postcode Lookup Config -->
					<div class="form-group">
						<div class="row ml-0 mr-0">
							<div class="col-sm-2 control-label">
								<h4 class="heading">Postcode Lookup</h4>
							</div>
						</div>
						<div class="row ml-0 mr-0">
							<label class="col-sm-2 control-label" for="craftyGlobal_postcode_status"><?php echo $craftyAdminLabels['label_postcode_status']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_postcode_status" class="form-control">
									<?php if ($craftyGlobal_postcode_status == '1') { ?>
										<option value="1" selected="selected">Enabled</option>
										<option value="0">Disabled</option>
									<?php } else { ?>
											<option value="1">Enabled</option>
											<option value="0" selected="selected">Disabled</option>
									<?php } ?>
								</select>
							</div>
						</div>
					</div>

					<!-- Phone Validation Config -->
					<div class="form-group">
						<div class="row ml-0 mr-0">
							<div class="col-sm-2 control-label">
								<h4 class="heading">Phone Validation</h4>
							</div>
						</div>
						<div class="row ml-0 mr-0">
							<label class="col-sm-2 control-label" for="craftyGlobal_phone_status"><?php echo $craftyAdminLabels['label_phone_status']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_phone_status" class="form-control">
									<?php if ($craftyGlobal_phone_status == '1') { ?>
										<option value="1" selected="selected">Enabled</option>
										<option value="0">Disabled</option>
									<?php } else { ?>
											<option value="1">Enabled</option>
											<option value="0" selected="selected">Disabled</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_phone_can_correct"><?php echo $craftyAdminLabels['label_phone_can_correct']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_phone_can_correct" class="form-control">
									<?php if ($craftyGlobal_phone_can_correct == '1') { ?>
										<option value="1" selected="selected">Enabled</option>
										<option value="0">Disabled</option>
									<?php } else { ?>
											<option value="1">Enabled</option>
											<option value="0" selected="selected">Disabled</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_phone_allowed_type"><?php echo $craftyAdminLabels['label_phone_allowed_type']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_phone_allowed_type" class="form-control">
									<?php if ($craftyGlobal_phone_allowed_type == 'landline') { ?>
										<option value="all">All</option>
										<option value="mobile">Mobile</option>
										<option value="landline" selected="selected">Landline</option>
									<?php } else if ($craftyGlobal_phone_allowed_type == 'mobile') { ?>
										<option value="all">All</option>
										<option value="mobile" selected="selected">Mobile</option>
										<option value="landline">Landline</option>
									<?php } else { ?>
										<option value="all" selected="selected">All</option>
										<option value="mobile">Mobile</option>
										<option value="landline">Landline</option>
									<?php } ?>
								</select>
							</div>
						</div>
					</div>

					<!-- Email Validation Config -->
					<div class="form-group">
						<div class="row ml-0 mr-0">
							<div class="col-sm-2 control-label">
								<h4 class="heading">Email Validation</h4>
							</div>
						</div>
						<div class="row ml-0 mr-0">
							<label class="col-sm-2 control-label" for="craftyGlobal_email_status"><?php echo $craftyAdminLabels['label_email_status']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_email_status" class="form-control">
									<?php if ($craftyGlobal_email_status == '1') { ?>
										<option value="1" selected="selected">Enabled</option>
										<option value="0">Disabled</option>
									<?php } else { ?>
											<option value="1">Enabled</option>
											<option value="0" selected="selected">Disabled</option>
									<?php } ?>
								</select>
							</div>
						</div>
						<div class="row ml-0 mr-0 mt-15">
							<label class="col-sm-2 control-label" for="craftyGlobal_email_allow_high_risk"><?php echo $craftyAdminLabels['label_email_allow_high_risk']; ?></label>
							<div class="col-sm-10">
								<select name="craftyGlobal_email_allow_high_risk" class="form-control">
									<?php if ($craftyGlobal_email_allow_high_risk == '1') { ?>
										<option value="1" selected="selected">Enabled</option>
										<option value="0">Disabled</option>
									<?php } else { ?>
											<option value="1">Enabled</option>
											<option value="0" selected="selected">Disabled</option>
									<?php } ?>
								</select>
							</div>
						</div>
					</div>
				</form>
			</div>
		</div>
	</div>
</div>
<?php echo $footer; ?>
