<?php
/**
 * Fetchify
 *
 * @author       	ClearCourse Business Services Ltd t/a Fetchify
 * @link            https://fetchify.com
 * @copyright  		Copyright (c) 2022, ClearCourse Business Services Ltd
 * @version			4.2.0
**/

class ControllerExtensionModuleCraftyGlobal extends Controller {
    public function index() {
		$isSSL = $this->config->get('config_secure'); //Get the value whether website uses SSL
		if(isset($isSSL)){
			$data['absolutePath'] = $this->config->get('config_ssl');
		}
		else {
			$data['absolutePath'] = $this->config->get('config_url');
		}
		$this->load->language('extension/module/craftyGlobal');
		// Load countries
		$this->load->model('localisation/country');
		$data['countries'] = $this->model_localisation_country->getCountries();
		$data['iso2'] = array();
		foreach ($data['countries'] as $key => $value) {
			if ($value['status'] == '1') {
				$temp =  array(
					'country_id' => $value['country_id'],
					'iso_2' => $value['iso_code_2'],
				);
				array_push($data['iso2'], $temp);
			}
		}
		$data['iso2'] = json_encode($data['iso2']);
		$configValues= array(
			'status' => 'text',
			'access_token' => 'text',
			'postcode_status' => 'text',
			'autocomplete_status' => 'text',
			'ambient' => 'text',
			'mode' => 'int',
			'default_placeholder' => 'text',
			'country_button' => 'text',
			'country_placeholder' => 'text',
			'search_label' => 'text',
			'generic_error' => 'text',
			'no_results' => 'text',
			'showLogo' => 'int',
			'hideFields' => 'int',
			'use_first_line' => 'int',
			'phone_status' => 'text',
			'phone_can_correct' => 'int',
			'phone_allowed_type' => 'text',
			'email_status' => 'text',
			'email_allow_high_risk' => 'int'
		);
		$data['craftyGlobalConfig']= array();
		foreach ($configValues as $key => $value_type) {
			$data['craftyGlobalConfig'][$key] = html_entity_decode($this->config->get('module_craftyGlobal_'.$key));
			if ($value_type == 'int') {
				$data['craftyGlobalConfig'][$key] = (int) $data['craftyGlobalConfig'][$key];
			}
		}
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/extension/module/craftyGlobal')) {
			return $this->load->view($this->config->get('config_template') . '/template/extension/module/craftyGlobal', $data);
		} else {
			return $this->load->view('extension/module/craftyGlobal', $data);
		}
    }
}
