<?php
/**
 * Fetchify
 *
 * @author       	ClearCourse Business Services Ltd t/a Fetchify
 * @link            https://fetchify.com
 * @copyright  		Copyright (c) 2022, ClearCourse Business Services Ltd
 * @version			2.1.0
**/

class ControllerModuleCraftyGlobal extends Controller {
    public function index() {
		$isSSL = $this->config->get('config_secure'); //Get the value whether website uses SSL
		if($isSSL === '1'){
			$data['absolutePath'] = $this->config->get('config_ssl');
		}
		else {
			$data['absolutePath'] = $this->config->get('config_url');
		}
		$this->load->language('module/craftyGlobal');
		// Load countries
		$this->load->model('localisation/country');
		$data['countries'] = $this->model_localisation_country->getCountries();
		$data['iso2'] = array();
		foreach ($data['countries'] as $key => $value) {
			if ($value['status'] == '1') {
				$temp =  array(
					'country_id' => $value['country_id'],
					'iso_2' => $value['iso_code_2'],
				);
				array_push($data['iso2'], $temp);
			}
		}
		$data['iso2'] = json_encode($data['iso2']);
		$configValues= array(
			'access_token',
			'postcode_status',
			'autocomplete_status',
			'mode',
			'ambient',
			'accent',
			'showLogo',
			'hideFields',
			'default_placeholder',
			'country_button',
			'country_placeholder',
			'generic_error',
			'no_results',
			'search_label',
			'useLine1',
			'phone_status',
			'phone_can_correct',
			'phone_allowed_type',
			'email_status',
			'email_allow_high_risk'
		);
		$data['craftyGlobalConfig']= array();
		foreach ($configValues as $elem) {
			$data['craftyGlobalConfig'][$elem] = html_entity_decode($this->config->get('craftyGlobal_'.$elem));
		}
		if($data['craftyGlobalConfig']['accent'] == '') $data['craftyGlobalConfig']['accent'] = 'default';
		if(version_compare(VERSION, "2.2", "<")){
			return $this->load->view('default/template/module/craftyGlobal.tpl', $data);
		}
		else {
			return $this->load->view('module/craftyGlobal.tpl', $data);
		}
        
    }
}
