/**
 * Fetchify
 *
 * @author       	ClearCourse Business Services Ltd t/a Fetchify
 * @link            https://fetchify.com
 * @copyright  		Copyright (c) 2022, ClearCourse Business Services Ltd
 * @version			4.2.0
**/

jQuery(document).ready(function() {
	addAutocompleteProduct();
	addPostcodeProduct();
	addPhoneProduct();
	addEmailProduct();
});

function saveJournalCheckout(line_1, isAutocomplete) {
	if (window._QuickCheckout !== undefined) {
		var data = window._QuickCheckout.order_data;
		if (line_1.attr('id').indexOf("payment") !== -1) {
			data.payment_address_1 = document.getElementById("input-payment-address-1").value;
			data.payment_address_2 = document.getElementById("input-payment-address-2").value;
			data.payment_city = document.getElementById("input-payment-city").value;
			data.payment_company = document.getElementById("input-payment-company").value;
			data.payment_country = $("#input-payment-country option:selected").text();
			data.payment_country_id = document.getElementById("input-payment-country").value;
			data.payment_postcode = document.getElementById("input-payment-postcode").value;
			if (!isAutocomplete) {
				data.payment_zone_id = document.getElementById("input-payment-zone").value;
				data.payment_zone = $("#input-payment-zone option:selected").text();
			}
		}

		if (line_1.attr('id').indexOf("shipping") !== -1) {
			data.shipping_address_1 = document.getElementById("input-shipping-address-1").value;
			data.shipping_address_2 = document.getElementById("input-shipping-address-2").value;
			data.shipping_city = document.getElementById("input-shipping-city").value;
			data.shipping_company = document.getElementById("input-shipping-company").value;
			data.shipping_country = $("#input-shipping-country option:selected").text();
			data.shipping_country_id = document.getElementById("input-shipping-country").value;
			data.shipping_postcode = document.getElementById("input-shipping-postcode").value;
			if (!isAutocomplete) {
				data.shipping_zone_id = document.getElementById("input-shipping-zone").value;
				data.shipping_zone = $("#input-shipping-zone option:selected").text();
			}
		}
	}
}

function saveAutocompleteCounty(zone_id, line_1) {
	if (window._QuickCheckout !== undefined) {
		var data = window._QuickCheckout.order_data;
		if (line_1.attr('id').indexOf("payment") !== -1) {
			data.payment_zone_id = zone_id;
			data.payment_zone = $('select>option[value=' + zone_id +']').text();
		}

		if (line_1.attr('id').indexOf("shipping") !== -1) {
			data.shipping_zone_id = zone_id;
			data.shipping_zone = $('select>option[value=' + zone_id +']').text();
		}
	}
}

/**
 *
 * Autocomplete Product
 *
 */
function addAutocompleteProduct() {
	if (craftyGlobalConfig.autocomplete_status !== '1') {
		return;
	}

	if (craftyGlobalConfig.default_placeholder === '') {
		craftyGlobalConfig.default_placeholder = "Start with post/zip code or street";
	}

	var autocompleteInterval = setInterval(function(){
		if (jQuery('#input-payment-address-1').length || jQuery('#input-address-1').length) {
			clearInterval(autocompleteInterval);
			var config = {
				accessToken: craftyGlobalConfig.access_token,
				active:			craftyGlobalConfig.autocomplete_status,
				tag: 			'oc-aac',
				domMode:		'object',
				gfxMode:		craftyGlobalConfig.mode,
				style:{
					ambient:	craftyGlobalConfig.ambient,
					accent:		'default'
				},
				showLogo:		craftyGlobalConfig.showLogo === '1',
				texts: {
						country_button: craftyGlobalConfig.country_button,
						country_placeholder: craftyGlobalConfig.country_placeholder,
						default_placeholder: craftyGlobalConfig.default_placeholder,
						generic_error: craftyGlobalConfig.generic_error,
						no_results: craftyGlobalConfig.no_results,
						search_label: craftyGlobalConfig.search_label
				},
				onResultSelected: function(c2a, elements, address){
					elements.company.value = address.company_name;
					var county ={code: address.province_code, name: address.province_name, province: address.province};
					// Change country based on iso_2
					for (var key in craftyGlobalCountries) {
						if(craftyGlobalCountries.hasOwnProperty(key)) {
							if (craftyGlobalCountries[key].iso_2 === address.country.iso_3166_1_alpha_2) {
								jQuery(elements.country).val(craftyGlobalCountries[key].country_id);
							}
						}
					}

					// Set UK Crown Dependency
					if(address.country.iso_3166_1_alpha_2 == 'GB'){
						var postcode = address.postal_code.substring(0,2);
						if (postcode == 'GY' && jQuery.inArray('GG', getAllowedCountries())>-1) {
							jQuery(elements.country).val('256');
						}
						if (postcode == 'JE' && jQuery.inArray('JE', getAllowedCountries())>-1) {
							jQuery(elements.country).val('257');
						}
						if (postcode == 'IM' && jQuery.inArray('IM', getAllowedCountries())>-1) {
							jQuery(elements.country).val('254');
						}
					}
					jQuery(elements.country).trigger('change');

					jQuery(document).ajaxStop(function() {
						if(address.country_name !== 'United Kingdom'){
							if (elements.county.value != '0') {
								c2a.setCounty(elements.county, county);
								jQuery(elements.county).trigger('change');
								saveAutocompleteCounty(elements.county.value, jQuery(elements.line_1));
							}
						}
						else {
							craftyCountyChange(address, elements);
						}
						$(document).unbind("ajaxStop");
					});
					
					saveJournalCheckout(jQuery(elements.line_1), true);					

					if(craftyGlobalConfig.hideFields === 1){
						var form = jQuery(elements.country).closest('fieldset');
						if(!form.length){
							form = jQuery(elements.country).closest('form');
						}
						showFields(form, true);
					}
				},
				onError: function(c2a, elements, address){
					if(craftyGlobalConfig.hideFields === 1){
						var form = jQuery(elements.country).closest('fieldset');
						if(!form.length){
							form = jQuery(elements.country).closest('form');
						}
						showFields(form, false);
					}
				},
				countryMatchWith: 'iso_2',
				enabledCountries: getAllowedCountries()
			}

			window.cc_c2a = new clickToAddress(config);

			setInterval(function(){
				if (jQuery('#input-payment-postcode').length) {
					_add_lookup({
						prefix:	'payment',
						fields	:{
							postcode_obj:	jQuery('#input-payment-postcode')[0],
							company_obj:	jQuery('#input-payment-company')[0],
							street1_obj:	jQuery('#input-payment-address-1')[0],
							street2_obj:	jQuery('#input-payment-address-2')[0],
							town_obj:		jQuery('#input-payment-city')[0],
							county_obj:		jQuery('#input-payment-zone')[0],
							country_obj:	jQuery('#input-payment-country')[0]
						}
					});
				}
				if (jQuery('#input-shipping-postcode').length) {
					_add_lookup({
						prefix:	'shipping',
						fields	:{
							postcode_obj:	jQuery('#input-shipping-postcode')[0],
							company_obj:	jQuery('#input-shipping-company')[0],
							street1_obj:	jQuery('#input-shipping-address-1')[0],
							street2_obj:	jQuery('#input-shipping-address-2')[0],
							town_obj:		jQuery('#input-shipping-city')[0],
							county_obj:		jQuery('#input-shipping-zone')[0],
							country_obj:	jQuery('#input-shipping-country')[0]
						}
					});
				}
				if (jQuery('#input-postcode').length && jQuery('#input-postcode').closest('fieldset').length !== 0) {
					_add_lookup({
						prefix:	false,
						fields	:{
							postcode_obj:	jQuery('#input-postcode')[0],
							company_obj:	jQuery('#input-company')[0],
							street1_obj:	jQuery('#input-address-1')[0],
							street2_obj:	jQuery('#input-address-2')[0],
							town_obj:		jQuery('#input-city')[0],
							county_obj:		jQuery('#input-zone')[0],
							country_obj:	jQuery('#input-country')[0]
						}
					});
				} else if (jQuery('#input-postcode').length && window.Journal !== undefined) {
					_add_lookup({
						prefix:	false,
						fields	:{
							postcode_obj:	jQuery('#input-postcode')[0],
							company_obj:	jQuery('#input-company')[0],
							street1_obj:	jQuery('#input-address-1')[0],
							street2_obj:	jQuery('#input-address-2')[0],
							town_obj:		jQuery('#input-city')[0],
							county_obj:		jQuery('#input-zone')[0],
							country_obj:	jQuery('#input-country')[0]
						}
					});
				}
			},200);
		}
	},200);
}

function _add_lookup(opencart){
	if (!opencart.prefix) {
		if (!jQuery('#cc_search_input').length && craftyGlobalConfig.use_first_line != 1) {
			var tmp_html;
			tmp_html = jQuery('<div class="form-group" style="display: none;">'+
									'<label class="cc-manual-button cc-button col-sm-2 control-label">'+
										'Enter Address Manually'+
									'</label>'+
								'</div>'+'<div class="form-group"><label class="col-sm-2 control-label">Search Address</label>'+
			'<div class="col-sm-10"><input id="cc_search_input" class="form-control" type="text" placeholder="'+craftyGlobalConfig.default_placeholder+'"/></div>');
			jQuery(tmp_html).insertBefore(jQuery(opencart.fields.street1_obj).parents().eq(1));
			tmp_html.find('.cc-button').css({display: 'none', float:'right', cursor:'pointer', 'font-size': '11px'});
			if(craftyGlobalConfig.hideFields === 1){
				var form = jQuery(opencart.fields.street1_obj).closest('fieldset');
				if(!form.length){
					form = jQuery(opencart.fields.street1_obj).closest('form');
				}

				var cc_manual = form.find('.cc-manual-button');
				cc_manual.css('display', '');
				cc_manual.on('click',function(){
					showFields(form, false);
					jQuery(this).hide(200);
				});

				var domKeys = Object.keys(opencart.fields);
				for(var i=0; i<domKeys.length; i++){
					if(domKeys[i] !== 'company_obj')
						jQuery(opencart.fields[domKeys[i]]).attr('cc-hide', 1);
				}
				jQuery(opencart.fields.county_obj.input).attr('cc-hide', 1);

				if(jQuery(opencart.fields.street1_obj).val() === ''){
					form.find('[cc-hide=1]').closest('div.form-group').hide();
					cc_manual.closest('div').show();
					cc_manual.show();
				}
			}
			window.cc_c2a.attach({
				search:		jQuery('#cc_search_input')[0],
				line_1:		opencart.fields.street1_obj,
				line_2:		opencart.fields.street2_obj,
				town:		opencart.fields.town_obj,
				company:	opencart.fields.company_obj,
				postcode:	opencart.fields.postcode_obj,
				county:		opencart.fields.county_obj,
				country:	opencart.fields.country_obj
			});
		} else if (!document.getElementById('input-address-1').getAttribute('cc_applied') && craftyGlobalConfig.use_first_line == 1) {
			window.cc_c2a.attach({
				search:		opencart.fields.street1_obj,
				line_1:		opencart.fields.street1_obj,
				line_2:		opencart.fields.street2_obj,
				town:		opencart.fields.town_obj,
				company:	opencart.fields.company_obj,
				postcode:	opencart.fields.postcode_obj,
				county:		opencart.fields.county_obj,
				country:	opencart.fields.country_obj
			});
		}
	} else if (!jQuery('#'+opencart.prefix+'_cc_search_input').length && craftyGlobalConfig.use_first_line != 1) {
		var tmp_html;
		// check if we are on billing form AND that user is not logged in since
		var streetFieldset = jQuery(opencart.fields.street1_obj).closest('fieldset')[0]
		var nameFieldset = jQuery(opencart.fields.street1_obj).closest('row').find('[name="firstname"]').closest('fieldset')[0]
		if (opencart.prefix === 'payment' && streetFieldset !== nameFieldset) {
			tmp_html = jQuery('<div class="form-group cc-partial-hide"><label class="control-label">Search Address</label>'+
						'<label class="cc-manual-button cc-button control-label">'+
										'Enter Address Manually'+
									'</label>'+
			'<input id="'+opencart.prefix+'_cc_search_input" class="form-control cc_search_input" type="text" placeholder="'+craftyGlobalConfig.default_placeholder+'"/></div>');
			jQuery(tmp_html).insertBefore(jQuery(opencart.fields.street1_obj).parents().eq(0));
		}
		else {
			tmp_html = jQuery('<div class="form-group" style="display: none;">'+
									'<label class="cc-manual-button cc-button col-sm-2 control-label">'+
										'Enter Address Manually'+
									'</label>'+
								'</div>'+'<div class="form-group"><label class="col-sm-2 control-label">Search Address</label>'+
			'<div class="col-sm-10"><input id="'+opencart.prefix+'_cc_search_input" class="form-control" type="text" placeholder="'+craftyGlobalConfig.default_placeholder+'"/></div>');
			var journalToggle = window._QuickCheckout !== undefined ? 0 : 1;
			jQuery(tmp_html).insertBefore(jQuery(opencart.fields.street1_obj).parents().eq(journalToggle));
		}
		tmp_html.find('.cc-button').css({display: 'none', float:'right', cursor:'pointer', 'font-size': '11px'});
		if(craftyGlobalConfig.hideFields === 1){
			var form = jQuery(opencart.fields.street1_obj).closest('fieldset');
			if(!form.length){
				form = jQuery(opencart.fields.street1_obj).closest('form');
			}

			var cc_manual = form.find('.cc-manual-button');
			cc_manual.css('display', '');
			cc_manual.on('click',function(){
				showFields(form, false);
				jQuery(this).hide(200);
			});

			var domKeys = Object.keys(opencart.fields);
			for(var i=0; i<domKeys.length; i++){
				if(domKeys[i] !== 'company_obj')
					jQuery(opencart.fields[domKeys[i]]).attr('cc-hide', 1);
			}
			jQuery(opencart.fields.county_obj.input).attr('cc-hide', 1);

			if(jQuery(opencart.fields.street1_obj).val() === ''){
				form.find('[cc-hide=1]').closest('div.form-group').hide();
				cc_manual.closest('div').show();
				cc_manual.show();
			}
		}
		window.cc_c2a.attach({
			search:		jQuery('#'+opencart.prefix+'_cc_search_input')[0],
			line_1:		opencart.fields.street1_obj,
			line_2:		opencart.fields.street2_obj,
			town:		opencart.fields.town_obj,
			company:	opencart.fields.company_obj,
			postcode:	opencart.fields.postcode_obj,
			county:		opencart.fields.county_obj,
			country:	opencart.fields.country_obj
		});
	} else if (!document.getElementById('input-'+opencart.prefix+'-address-1').getAttribute('cc_applied') && craftyGlobalConfig.use_first_line == 1) {
		window.cc_c2a.attach({
			search:		opencart.fields.street1_obj,
			line_1:		opencart.fields.street1_obj,
			line_2:		opencart.fields.street2_obj,
			town:		opencart.fields.town_obj,
			company:	opencart.fields.company_obj,
			postcode:	opencart.fields.postcode_obj,
			county:		opencart.fields.county_obj,
			country:	opencart.fields.country_obj
		});
	}
}

function showFields(form, isResultSelected){
	form.find('[cc-hide=1]').closest('div.form-group').show(200);
	if(isResultSelected) {
		if (form.find('.cc_search_input').closest('div').hasClass('cc-partial-hide')) form.find('.cc-button').hide(200);
		else form.find('.cc-button').closest('div').hide(200);
	}
	if (!isResultSelected) {
		form.find('.cc_search_input').hide(200);
		jQuery(form.find('.cc_search_input').closest('div.form-group').find('label.control-label')[0]).hide(200);
	}
}

function getAllowedCountries(){
	var countryNames = [];
	for (var key in craftyGlobalCountries) {
		if(craftyGlobalCountries.hasOwnProperty(key)) {
			countryNames.push(craftyGlobalCountries[key].iso_2);
		}
	}
	return countryNames;
}

function craftyCountyChange(address,elements) {
	var craftyCountyOptions = jQuery('#'+elements.county.id+' option');
	for (var i = 0; i < craftyCountyOptions.length; i++) {
		if (jQuery(craftyCountyOptions[i]).text() === address.alternative_province) {
			jQuery(craftyCountyOptions[i]).prop('selected', 'selected');
			jQuery(elements.county).trigger('change');
			saveAutocompleteCounty(elements.county.value, jQuery(elements.line_1));
			return;
		}
	}

	var craftyCountyData = [
		['Argyllshire', 3517],
		['Ayrshire', 3574],
		['Banffshire', 3570],
		['Berwickshire', 3588],
		['Brecknockshire', 3584],
		['Buteshire', 3517],
		['Caernarfonshire', 3555],
		['Caithness', 3559],
		['Cardiganshire', 3528],
		['County Durham', 3539],
		['Cumberland', 3955],
		['Dumfriesshire', 3537],
		['Dunbartonshire', 3541],
		['Glamorgan', 3526],
		['Huntingdonshire', 3525],
		['Inverness-shire', 3559],
		['Isle of Lewis', 3609],
		['Isle of Skye', 3609],
		['Isles of Scilly', 3532],
		['Kincardineshire', 3514],
		['Kinross-Shire', 3583],
		['Kirkcudbrightshire', 3537],
		['Lanarkshire', 3551],
		['Merioneth', 3555],
		['Middlesex', 3553],
		['Montgomeryshire', 3584],
		['Morayshire', 3570],
		['Nairnshire', 3559],
		['Orkney', 3580],
		['Peeblesshire', 3588],
		['Perthshire', 3583],
		['Radnorshire', 3584],
		['Ross-shire', 3559],
		['Roxburghshire', 3588],
		['Selkirkshire', 3588],
		['Shetland', 3589],
		['Stirlingshire', 3596],
		['Sussex', 3607],
		['Sutherland', 3559],
		['Westmorland', 3955],
		['Wigtownshire', 3537],
		['Yorkshire', 3576]
	];

	for(i=0;i<craftyCountyData.length;i++) {
		var currentCounty = craftyCountyData[i][0];
		var currentValue = craftyCountyData[i][1];
		if (address.alternative_province === currentCounty) {
			$('select>option[value=' + currentValue +']').prop('selected', 'selected');
			jQuery(elements.county).trigger('change');
			saveAutocompleteCounty(currentValue, jQuery(elements.line_1));
			return;
		}
	}
}

/**
 *
 * Postcode Product
 *
 */
function addPostcodeProduct(){
	if(craftyGlobalConfig.postcode_status !== '1') {
		return;
	}

	if(	typeof jQuery == 'undefined' ||
	typeof CraftyPostcodeCreate == 'undefined' ||
	typeof craftyGlobalConfig.postcode_status == 'undefined' ||
	craftyGlobalConfig.postcode_status != 1 ||
		(!jQuery('#input-payment-country').length && !jQuery('#input-shipping-country').length && !jQuery('#input-country').length)) {
			setTimeout(addPostcodeProduct, 200);
		}
	else {
		setInterval(crafty_interval, 200);
	}
}

var _cp_config = {
	selectFirstAddress:		0,
	enabledCountries:		['222', '254', '256', '257'],
	busy_img_url:			'catalog/view/javascript/craftyclicksGlobal/img/crafty_postcode_busy.gif',
	traditional_county:		1
};

var prefixes = [
	'-payment',
	'-shipping',
	''
];

function crafty_interval(){
	for(var j=0; j<prefixes.length; j++){
		var country_elem = jQuery('#input'+prefixes[j]+'-country');
		if(country_elem.length){
			if(jQuery.inArray(country_elem.val(), _cp_config.enabledCountries) != -1 && jQuery(country_elem).attr('cc-applied') != '1'){
				jQuery(country_elem).attr('cc-applied', '1');
				addPostcodeLookup(prefixes[j]);
			}
		}
	}
	var checkoutPage = jQuery('.checkout-checkout').length;
	if(	checkoutPage && prefixes.length > 1 ||
		!checkoutPage && prefixes.length > 2)
			setTimeout(function(){
				crafty_interval(prefixes);
			}, 200);
}

function addPostcodeLookup(prefix){
	var craftyFieldWidth = jQuery('#input'+prefix+'-postcode').css('width');
	UKArrangement(prefix);
	addCraftyButton(prefix);
	if(prefix == '-payment' && !jQuery('#payment-new').length){
		var craftyResult_1 = jQuery('<div class="form-group" id="crafty_postcode_result_display'+prefix+'"></div>');

	}
	else {
		var craftyResult_1 = jQuery('<div class="form-group">'+
										'<label class="col-sm-2 control-label"></label>'+
										'<div class="col-sm-10" id="crafty_postcode_result_display'+prefix+'"></div>'+
									'</div>');
	}
	var cp_obj = CraftyPostcodeCreate();
	cp_obj.set('access_token',			craftyGlobalConfig.access_token);
	cp_obj.set('result_elem_id',		'crafty_postcode_result_display'+prefix);
	cp_obj.set('max_width',				craftyFieldWidth);
	cp_obj.set('traditional_county',	_cp_config.traditional_county);
	cp_obj.set('elem_company',			'input'+prefix+'-company');
	cp_obj.set('elem_street1',			'input'+prefix+'-address-1');
	cp_obj.set('elem_street2',			'input'+prefix+'-address-2');
	cp_obj.set('elem_town',				'input'+prefix+'-city');
	cp_obj.set('elem_postcode',			'input'+prefix+'-postcode');
	cp_obj.set('elem_county',			'input'+prefix+'-zone');
	cp_obj.set('on_result_ready',		function(){
		craftyResult_1.find('select').addClass('form-control');
		craftyResult_1.show();
	});
	cp_obj.set('res_autoselect',		_cp_config.selectFirstAddress);
	cp_obj.set('busy_img_url',			_cp_config.busy_img_url);
	cp_obj.set('on_result_selected',	function(){
		var country_element = jQuery('#input'+prefix+'-country');
		var county_element = jQuery('#input'+prefix+'-zone');



		var postcodeInitial = _cp_addr_data.postcode.substring(0,2);
		switch(postcodeInitial){
			case 'IM':
				country_element.val(254).trigger('change');
				break;
			case 'GY':
				country_element.val(256).trigger('change');
				break;
			case 'JE':
				country_element.val(257).trigger('change');
				break;
			default:
				country_element.val(222).trigger('change');
				break;
		}
		jQuery('#input'+prefix+'-zone option:first').attr('cc-tagged', 1);
		var journalToggle = window._QuickCheckout !== undefined ? 1 : '1';
		var countyChecker = setInterval(function(){
			if (jQuery('#input'+prefix+'-zone option:first').attr('cc-tagged') !== journalToggle) {
				countyChange(jQuery('#input'+prefix+'-zone option'), jQuery('#input'+prefix+'-zone'));
				clearInterval(countyChecker);
			}
		},10);
		var cp_line1 = jQuery('#input'+prefix+'-address-1');
		if(cp_line1.val().length < 5){
			var cp_line2 = jQuery('#input'+prefix+'-address-2');
			cp_line1.val(cp_line1.val() + ', ' + cp_line2.val());
			cp_line2.val('');
		}
	});
	// Do the lookup
	jQuery('#cc-button'+prefix).on('click', function(){
		var pc_elem =	jQuery('#input'+prefix+'-postcode').closest('div.form-group');
		var disp_elem =	jQuery('#crafty_postcode_result_display'+prefix);
		if(!disp_elem.length){
			pc_elem.after(craftyResult_1);
		}
		cp_obj.doLookup();
	});

	// Country change triggers
	jQuery('#input'+prefix+'-country').on('change', function(){
		if(jQuery.inArray(jQuery(this).val(), _cp_config.enabledCountries) != -1){
			UKArrangement(prefix);
			addCraftyButton(prefix);
		}
		else {
			nonUKArrangement(prefix);
		}
		saveJournalCheckout(jQuery('#input'+prefix+'-address-1'), false);
	});
}

// Add lookup button
function addCraftyButton(prefix){
	var btn_elem = jQuery('#cc-button'+prefix);
	if(btn_elem.length) {
		btn_elem.closest('div.input-group-btn').show();
		return;
	}
	var craftyHtml = jQuery('<div class="input-group-btn">'+
								'<div id="cc-button'+prefix+'" class="btn btn-primary">'+
									'Find Address'+
								'</div>'+
							'</div>');
	var pc_elem = jQuery('#input'+prefix+'-postcode');
	pc_elem.wrap('<div id="cc-input-group'+prefix+'" class="input-group"></div>');
	pc_elem.after(craftyHtml);
	craftyHtml.find('btn').css({fontSize: '12px'});
}

// Form arrangement for UK
function UKArrangement(prefix){
	jQuery('#cc-input-group'+prefix).addClass('input-group');
	var company_elem = jQuery('#input'+prefix+'-company').closest('div.form-group');
	var pc_elem = jQuery('#input'+prefix+'-postcode').closest('div.form-group');
	company_elem.before(pc_elem);
	var display_elem = jQuery('#crafty_postcode_result_display'+prefix);
	if(display_elem.hasClass('form-group')){
		pc_elem.after(display_elem);
	}
	else {
		pc_elem.after(display_elem.closest('div.form-group'));
	}
}

// Form arrangement for non-UK
function nonUKArrangement(prefix){
	jQuery('#cc-input-group'+prefix).removeClass('input-group');
	jQuery('#cc-button'+prefix).closest('div.input-group-btn').hide();
	var display_elem = jQuery('#crafty_postcode_result_display'+prefix);
	if(display_elem.hasClass('form-group')){
		display_elem.hide();
	}
	else {
		display_elem.closest('div.form-group').hide();
	}
	var city_elem = jQuery('#input'+prefix+'-city').closest('div.form-group');
	var pc_elem = jQuery('#input'+prefix+'-postcode').closest('div.form-group');
	city_elem.after(pc_elem);
}

function countyChange(inputOptions, input) {
	var inList = false;
	for(var i=0; i<inputOptions.length; i++){
		if(jQuery(inputOptions[i]).html().toUpperCase() === _cp_addr_data.traditional_county){
				input.val(jQuery(inputOptions[i]).val());
				inList = true;
		}
	}
	if (!inList) {
		var countyData = [
			['ARGYLLSHIRE', 3517],
			['AYRSHIRE', 3574],
			['BANFFSHIRE', 3570],
			['BERWICKSHIRE', 3588],
			['BRECKNOCKSHIRE', 3584],
			['BUTESHIRE', 3517],
			['CAERNARFONSHIRE', 3555],
			['CAITHNESS', 3559],
			['CARDIGANSHIRE', 3528],
			['COUNTY DURHAM', 3539],
			['CUMBERLAND', 3955],
			['DUMFRIESSHIRE', 3537],
			['DUNBARTONSHIRE', 3541],
			['GLAMORGAN', 3526],
			['HUNTINGDONSHIRE', 3525],
			['INVERNESS-SHIRE', 3559],
			['ISLE OF LEWIS', 3609],
			['ISLE OF SKYE', 3609],
			['ISLES OF SCILLY', 3532],
			['KINCARDINESHIRE', 3514],
			['KINROSS-SHIRE', 3583],
			['KIRKCUDBRIGHTSHIRE', 3537],
			['LANARKSHIRE', 3551],
			['MERIONETH', 3555],
			['MIDDLESEX', 3553],
			['MONTGOMERYSHIRE', 3584],
			['MORAYSHIRE', 3570],
			['NAIRNSHIRE', 3559],
			['ORKNEY', 3580],
			['PEEBLESSHIRE', 3588],
			['PERTHSHIRE', 3583],
			['RADNORSHIRE', 3584],
			['ROSS-SHIRE', 3559],
			['ROXBURGHSHIRE', 3588],
			['SELKIRKSHIRE', 3588],
			['SHETLAND', 3589],
			['STIRLINGSHIRE', 3596],
			['SUSSEX', 3607],
			['SUTHERLAND', 3559],
			['WESTMORLAND', 3955],
			['WIGTOWNSHIRE', 3537],
			['YORKSHIRE', 3576]
		];

		for(j=0;j<countyData.length;j++) {
			var currentCounty = countyData[j][0];
			var currentValue = countyData[j][1];
			if (_cp_addr_data.traditional_county === currentCounty) {
				input.val(currentValue);
			}
		}
	}
	saveJournalCheckout(input, false);
}

/**
 *
 * Phone Product
 *
 */
function addPhoneProduct() {
  if (craftyGlobalConfig.phone_status !== '1') {
	return;
  }

  var prefix = window.Journal !== undefined ? '' : '-payment';

  var phoneInterval = setInterval(function() {
	if (jQuery('#input' + prefix + '-telephone').length) {
	  clearInterval(phoneInterval);

	  if (!window.cc_c2a) {
		window.cc_c2a = new clickToAddress({
		  accessToken: craftyGlobalConfig.access_token
		});
	  }

	 window.cc_c2a.addPhoneVerify({
		phone: '#input' + prefix + '-telephone',
		country: function() {
			var selectedCountry = jQuery('#input-payment-country').val();

			for (var key in craftyGlobalCountries) {
				if (craftyGlobalCountries[key].country_id === selectedCountry) {
					return craftyGlobalCountries[key].iso_2;
				}
			}

			return '';
		},
		can_correct: craftyGlobalConfig.phone_can_correct,
		allowed_type: craftyGlobalConfig.phone_allowed_type,
		callback: function(result, error) {
			if (window._QuickCheckout !== undefined && craftyGlobalConfig.phone_can_correct === 1) {
				window._QuickCheckout.order_data.telephone = document.getElementById('input-telephone').value;			
			}	
		},
	  });
	 }
  }, 200);
}

/**
 *
 * Email Product
 *
 */
function addEmailProduct() {
  if (craftyGlobalConfig.email_status !== '1') {
	return;
  }

  var prefix = window.Journal !== undefined ? '' : '-payment';

  var emailInterval = setInterval(function() {
	if (jQuery('#input' + prefix + '-email').length) {
	  clearInterval(emailInterval);

	  if (!window.cc_c2a) {
		window.cc_c2a = new clickToAddress({
		  accessToken: craftyGlobalConfig.access_token
		});
	  }

	  window.cc_c2a.addEmailVerify({
		email: '#input' + prefix + '-email',
		allow_high_risk: craftyGlobalConfig.email_allow_high_risk
	  });
	}
  }, 200);
}
